package com.unitesk.reqcoverage;

import java.io.File;
import java.io.IOException;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.core.resources.IProject;
import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.IWorkspaceRoot;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.FileLocator;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtensionRegistry;
import org.eclipse.core.runtime.Platform;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

import com.unitesk.requality.eclipse.CoverageStorageSourceDescriptor;
import com.unitesk.requality.tests.ICoverageStorageSource;


/**
 * The activator class controls the plug-in life cycle
 */
public class Activator extends AbstractUIPlugin {

	// The plug-in ID
	public static final String PLUGIN_ID = "ttcn_requality"; //$NON-NLS-1$

	private static final String EXTENSION_NAME_NEW_TEST_DIALOGS = "com.requality.reqcoverage.newtestdialog";

	// The shared instance
	private static Activator plugin;
	
	/**
	 * The constructor
	 */
	public Activator() {
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
	 */
	public void start(BundleContext context) throws Exception {
		super.start(context);
		plugin = this;
	}

	/*
	 * (non-Javadoc)
	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
	 */
	public void stop(BundleContext context) throws Exception {
		plugin = null;
		super.stop(context);
	}

	/**
	 * Returns the shared instance
	 *
	 * @return the shared instance
	 */
	public static Activator getDefault() {
		return plugin;
	}
	
	public Map<String,Map<String,String>> getTestDescriptions(){
		Map<String, Map<String,String>> map = new HashMap<String, Map<String,String>>();
		IExtensionRegistry reg = Platform.getExtensionRegistry();
        IConfigurationElement[] configurationElements = reg
                .getConfigurationElementsFor(EXTENSION_NAME_NEW_TEST_DIALOGS);
        for (IConfigurationElement conf : configurationElements) {
            try {
            	String id = conf.getAttribute("id");
                map.put(id, new HashMap<String, String>());
                map.get(id).put("id", id);
                map.get(id).put("name", conf.getAttribute("name"));
                map.get(id).put("title", conf.getAttribute("title"));
                map.get(id).put("extension", conf.getAttribute("extension"));
                map.get(id).put("template", conf.getAttribute("template"));
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return map;
		
	}

	public static String getPath(String string) {
		if (Activator.getDefault() == null) {
			return string;
		} else {
			URL url;
			try {
				url = FileLocator.toFileURL(
						Activator.getDefault().getBundle().getResource(string));
				return new File(url.toURI()).getAbsolutePath();
			} catch (IOException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			catch (URISyntaxException e) {
				e.printStackTrace();
			}
		}
		return null;

	}
	public static List<IProject> getProjectsByNames(String[] split) {
		IWorkspace ws = ResourcesPlugin.getWorkspace();
		IWorkspaceRoot wr = ws.getRoot();
		List<IProject> projects = new ArrayList<IProject>();
		for(String s : split){
			if(s.equals(""))
				continue;
			IProject p = wr.getProject(s);
			if(p != null)
				projects.add(p);
		}
		return projects;
	}
}
