package com.unitesk.reqcoverage.tests;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.eclipse.jface.wizard.IWizard;
import org.eclipse.jface.wizard.WizardDialog;

import com.unitesk.reqcoverage.Activator;
import com.unitesk.reqcoverage.eclipse.wizards.NewTestWizard;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.TestGeneratorDescriptor;
import com.unitesk.requality.nodetypes.Requirement;
import com.unitesk.requality.nodetypes.TestPurpose;
import com.unitesk.requality.tests.ITestGenerator;
import com.unitesk.requality.tests.OperationResult;
import com.unitesk.requality.tests.TestDialogProvider;

public class NewTestGenerator implements ITestGenerator {
	public static final String WIZARD_ID = "com.unitesk.reqcoverage.newtest";
	private String target = null;
	public NewTestGenerator(){
		this(null);
	}
	public NewTestGenerator(String targ){
		target = targ;
	}
	@Override
	public boolean generateTest(TreeNode targetNode, TestDialogProvider dp) {
		//OperationResult or = dp.openCreateFileDialog("ttcn", "Create TTCN test");
 		WizardDialog wizard = dp.getWizard(WIZARD_ID, targetNode);
		if(target!=null)
			((NewTestWizard)dp.getLastWizard()).setSelectedId(target);
		OperationResult or = dp.openWizard(wizard, WIZARD_ID, targetNode);
		return or.getSucceedFlag();
	}
	@Override
	public boolean isEnabled(TreeNode target) {
		return target.getType().equals(TestPurpose.TYPE_NAME) || target.getType().equals(Requirement.TYPE_NAME);
	}
	@Override
	public TestGeneratorDescriptor[] getDescriptors(String id, String name) {
		List<TestGeneratorDescriptor> list = new ArrayList<TestGeneratorDescriptor>();
		Map<String,Map<String,String>> map = Activator.getDefault().getTestDescriptions();
		for(String s:map.keySet())
			list.add(new TestGeneratorDescriptor(s, map.get(s).get("name"), new NewTestGenerator(s)));
		return list.toArray(new TestGeneratorDescriptor[0]);
	}
}
